unit Unit1;

//{$mode Delphi}
{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Laz.VirtualTrees;

type
  
  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    VirtualStringTree1: TLazVirtualStringTree;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure VirtualStringTree1FreeNode(Sender: TBaseVirtualTree; 
      Node: PVirtualNode);
    procedure VirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree; 
      var NodeDataSize: Integer);
    procedure VirtualStringTree1GetText(Sender: TBaseVirtualTree; 
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; 
      var CellText: String);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

type
  TTestData = class
    Number: Integer;
    Text1: String;
    Text2: String;
  end;

  TNodeData = TTestData;
  PNodeData = ^TNodeData;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  P: PNodeData;
  data: TTestData;
  node: PVirtualNode;
begin
  node := VirtualStringTree1.AddChild(VirtualStringTree1.FocusedNode);
  P := VirtualStringTree1.GetNodeData(node);
  data := TTestData.Create;
  data.Number := Random(100);
  data.Text1 := 'A' + IntToStr(VirtualStringTree1.TotalCount);
  data.Text2 := 'B' + IntToStr(VirtualStringTree1.TotalCount);
  P^ := data;
  VirtualStringTree1.Expanded[VirtualStringTree1.FocusedNode] := true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  VirtualStringTree1.DeleteNode(VirtualStringTree1.FocusedNode);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  VirtualstringTree1.Selected[VirtualStringTree1.FocusedNode] := false;
  VirtualStringTree1.FocusedNode := nil;
end;

procedure TForm1.VirtualStringTree1FreeNode(Sender: TBaseVirtualTree; 
  Node: PVirtualNode);
var
  P: PNodeData;
begin
  P := Sender.GetNodeData(Node);
  TTestData(P^).Free;
end;

procedure TForm1.VirtualStringTree1GetNodeDataSize(Sender: TBaseVirtualTree; 
  var NodeDataSize: Integer);
begin
  NodeDataSize := SizeOf(PNodeData);
end;

procedure TForm1.VirtualStringTree1GetText(Sender: TBaseVirtualTree; 
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType; 
  var CellText: String);
var
  P: PNodeData;
  data: TTestData;
begin
  P := Sender.GetNodeData(Node);
  data := TTestData(P^);
  case Column of
    0: CellText := IntToStr(data.Number);
    1: CellText := data.Text1;
    2: CellText := data.Text2;
  end;
end;

end.

